-- Zombie Smasher 2
-- Hyperkani Oy 2012
-- Tero Pyylampi
--

-- Arcade mode for the game

-- for adding new enemies
addInterval = 2.0
timeLeft = 2.0

-- tracking time
timePassed = 0.0

-- when the game has lost
gameLost = false
levelStage = 0

-- total amount of enemies spawned
enemiesSpawned = 0

-- enemy speeds
speedBigHead = 1.4
speedBigGuy = 1.4
speedRatCat = 1.4
speedSmallBird = 0.9

-- initialize function which will be called after the game has been initialized
function init()
	-- lock camera
	setCameraLockState( true )
	-- set enemy speeds
	setSpeedMultipliers( 0.5, speedBigHead, speedBigGuy, 1.1, speedRatCat, speedSmallBird )
end

-- update function which will be called constantly from the main game engine
function update( dt )
	if gameLost == false then
		timeLeft = timeLeft - dt
		if timeLeft < 0 then			
			if enemiesSpawned < 60 then
				createNewEnemyUnit( 1, math.random( 0, 2 ), 0 )
				createNewEnemyUnit( 2, math.random( 0, 2 ), 1 )
				createNewEnemyUnit( 4, math.random( 0, 2 ), math.random( 0, 1 ) )
				enemiesSpawned = enemiesSpawned + 3
			elseif enemiesSpawned < 180 then
				e1 = math.random( 0, 2 )
				e2 = ( e1 + 1 ) % 3
				e3 = ( e2 + 1 ) % 3
				e4 = e1
				createNewEnemyUnit( math.random( 1, 2 ), e1, 0 )
				createNewEnemyUnit( 4, e2, 0 )
				createNewEnemyUnit( math.random( 1, 2 ), e3, 1 )
				createNewEnemyUnit( 4, e4, 1 )
				enemiesSpawned = enemiesSpawned + 4
			elseif enemiesSpawned < 300 then
				e1 = math.random( 0, 2 )
				e2 = ( e1 + 1 ) % 3
				e3 = ( e2 + 1 ) % 3
				e4 = e1
				createNewEnemyUnit( math.random( 1, 2 ), e1, 0 )
				createNewEnemyUnit( 5, e2, 0 )
				createNewEnemyUnit( math.random( 1, 2 ), e3, 1 )
				createNewEnemyUnit( 5, e4, 1 )
				enemiesSpawned = enemiesSpawned + 4
			elseif enemiesSpawned < 600 then
				e1 = math.random( 0, 2 )
				e2 = ( e1 + 1 ) % 3
				e3 = ( e2 + 1 ) % 3
				e4 = e1
				createNewEnemyUnit( math.random( 1, 2 ), e1, 0 )
				createNewEnemyUnit( 5, e2, 0 )
				createNewEnemyUnit( math.random( 1, 2 ), e3, 1 )
				createNewEnemyUnit( 5, e4, 1 )
				createNewEnemyUnit( 4, math.random( 0, 2 ), math.random( 0, 1 ) )
				enemiesSpawned = enemiesSpawned + 5
			else
				e1 = math.random( 0, 2 )
				e2 = ( e1 + 1 ) % 3
				e3 = ( e2 + 1 ) % 3
				e4 = ( e3 + 1 ) % 3
				e5 = ( e4 + 1 ) % 3
				e6 = ( e5 + 1 ) % 3	
				createNewEnemyUnit( math.random( 1, 2 ), e1, 0 )
				createNewEnemyUnit( math.random( 4, 5 ), e2, 0 )
				createNewEnemyUnit( math.random( 1, 2 ), e3, 0 )
				createNewEnemyUnit( math.random( 1, 2 ), e4, 1 )
				createNewEnemyUnit( math.random( 4, 5 ), e5, 1 )
				createNewEnemyUnit( math.random( 1, 2 ), e6, 1 )
				enemiesSpawned = enemiesSpawned + 6
			end
		
			-- increase speeds & decrease time
			if enemiesSpawned % 60 == 0 then
				speedBigHead = speedBigHead + 0.1
				speedBigGuy = speedBigGuy + 0.1
				speedRatCat = speedRatCat + 0.1
				speedSmallBird = speedSmallBird + 0.1
				setSpeedMultipliers( 0.5, speedBigHead, speedBigGuy, 1.1, speedRatCat, speedSmallBird )
				addInterval = addInterval - 0.1
				if addInterval <= 0.25 then
					addInterval = 0.25
				end
			end
			
			-- reset time
			timeLeft = addInterval
		end
	end
	
	-- initial zoom
	if levelStage == 0 and timePassed <= 1.0 then
		timePassed = timePassed + dt
		if timePassed > 1.0 then
			showString( "Survival Mode 2", 2.5, 0.5, 0.5, 0.65, 34 )
			--showString( "(Free camera)", 2.5, 0.5, 0.5, 0.5, 26 )
		end
	-- initial zoom to the center and then releasing the camera
	elseif levelStage == 0 and timePassed <= 3.0 then
		timePassed = timePassed + dt
		if timePassed > 3.0 then
			setNewZoomLevelTarget( 0.0, 16.0, 1.2, 1.0, 3 )
		end
	elseif levelStage == 0 and timePassed <= 4.0 then
		timePassed = timePassed + dt
		-- if timePassed > 4.0 then
			-- setCameraLockState( false )
		-- end
	-- camera playing a bit
	elseif levelStage == 0 and timePassed > 4.0 then
		timePassed = timePassed + dt
		if( timePassed >= 34.0 ) then
			timePassed = 5.0
			setNewZoomLevelTarget( -2.0 + math.random( 0, 4 ), 14.0 + math.random( 0, 3 ), 1.05 + ( math.random( 0, 2 ) / 10.0 ), 18.0, 0 )
		end
	-- level failed
	elseif levelStage == 1 then
		if timePassed <= 1.0 then
			timePassed = timePassed + dt
			if timePassed > 1.0 then
				if victoryAchieved then 
					showLevelCleared()
				else
					showLevelFailed()
				end
			end
		end
	end
end

-- called when a single enemy reaches the base
function enemyReachedBase( healthLeft )
	if healthLeft == 0 then
		gameLost = true
		setNewZoomLevelTarget( 0.0, 15.0, 1.0, 1.0, 3 )
		setCameraLockState( true )
		timePassed = 0.0
		levelStage = 1
	end
end

-- called when a single enemy has been destroyed
function enemyDestroyed( enemyType )
	-- showString( "enemyDestroyed", 1.0, 0.25, 0.5, 0.6, 26 )
end

-- called when a single weapon has been launched
function weaponLaunched( weaponType )
	-- showString( "weaponLaunched", 1.0, 0.25, 0.5, 0.5, 26 )
end