-- Zombie Smasher 2
-- Hyperkani Oy 2012
-- Tero Pyylampi
--

-- Campaign 2 Level 1, Introducing the "fast" enemy

-- for tracking the tutorial states
local timePassed = 0.0
-- tag saved for strings
local stringTag = 0
-- enemy data
local enemiesDestroyed = 0
local enemiesSpawned = 0
-- enemy interval
local enemyInterval = 0.9
local enemyIntervalTimeLeft = 4.0
-- victory & game lost flags
local victoryAchieved = false
local gameLost = false
-- last spawn stage
local lastStage = 0

-- initialize function which will be called after the game has been initialized
function init()
	-- lock camera
	setCameraLockState( true )
	-- set enemy speeds
	setSpeedMultipliers( 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 )
end

-- update function which will be called constantly from the main game engine
function update( dt )
	-- welcome string after 1.5 seconds
	if timePassed < 1.5 then
		timePassed = timePassed + dt
		if timePassed >= 1.5 then
			showString( "Level 11", 2.5, 0.5, 0.5, 0.65, 34 )
			timePassed = 1.5
		end
	-- initial zoom to the lower-right corner
	elseif timePassed < 3.0 then
		timePassed = timePassed + dt
		if timePassed >= 3.0 then
			setNewZoomLevelTarget( 24.0, 3.0, 2.0, 1.0, 3 )
			timePassed = 3.0
		end
	-- start slowly zooming away
	elseif timePassed < 4.0 then
		timePassed = timePassed + dt
		if timePassed >= 4.0 then
			setNewZoomLevelTarget( 24.0, 3.0, 1.7, 180, 0 )
			timePassed = 4.0
		end
	-- zooming back to the starting pos AFTER the game has been finished
	elseif victoryAchieved or gameLost then
		if timePassed <= 5.0 then
			timePassed = timePassed + dt
			if timePassed > 5.0 then
				if victoryAchieved then 
					showLevelCleared()
				else
					showLevelFailed()
				end
			end
		end
	end
	
	-- spawn rest of the enemies
	if gameLost == false and victoryAchieved == false then
		-- decrease time
		enemyIntervalTimeLeft = enemyIntervalTimeLeft - dt
		if enemyIntervalTimeLeft <= 0 then
			-- reset interval
			enemyIntervalTimeLeft = enemyInterval
			-- spawn enemy and increase counter
			if enemiesSpawned == 0 then
				createNewEnemyUnit( 4, 0, 1 )
				enemiesSpawned = enemiesSpawned + 1
				lastStage = 0
				enemyIntervalTimeLeft = enemyIntervalTimeLeft * 2
			elseif enemiesSpawned < 80 then
				stage = math.random( 0, 2 )
				if stage == lastStage then
					stage = ( stage + 1 ) % 3
				end
				lastStage = stage
				if math.random( 0, 1 ) == 0 then
					createNewEnemyUnit( 1, stage, 1 )
				else
					createNewEnemyUnit( 4, stage, 1 )
				end
				enemiesSpawned = enemiesSpawned + 1
				if enemiesSpawned == 80 then
					enemyInterval = 0.6
				end
			elseif enemiesSpawned < 160 then
				lastStage = ( lastStage + 1 ) % 3
				if math.random( 0, 1 ) == 0 then
					createNewEnemyUnit( 1, lastStage, 1 )
				else
					createNewEnemyUnit( 4, lastStage, 1 )
				end
				enemiesSpawned = enemiesSpawned + 1
			elseif enemiesSpawned < 200 then
				e1 = math.random( 0, 2 )
				e2 = ( e1 + 1 ) % 3
				createNewEnemyUnit( 1, e1, 1 )
				createNewEnemyUnit( 4, e2, 1 )
				enemiesSpawned = enemiesSpawned + 2
			end
		end
	end
	
	-- check for victory conditions
	if gameLost == false and victoryAchieved == false and enemiesSpawned >= 200 and enemiesLeftOnField() == 0 then
		victoryAchieved = true
		setNewZoomLevelTarget( 0.0, 15.0, 1.0, 1.0, 3 )
	end
end

-- called when a single enemy reaches the base
function enemyReachedBase( healthLeft )
	enemiesDestroyed = enemiesDestroyed + 1
	if healthLeft == 0 and gameLost == false then
		gameLost = true
		setNewZoomLevelTarget( 0.0, 15.0, 1.0, 1.0, 3 )
	end
end

-- called when a single enemy has been destroyed
function enemyDestroyed( enemyType )
	-- check for interval
	if enemiesLeftOnField() == 0 then
		enemyIntervalTimeLeft = 0
	end
	-- increase counter
	enemiesDestroyed = enemiesDestroyed + 1
end

-- called when a single weapon has been launched
function weaponLaunched( weaponType )
	--
end

-- calculates the amount of stars to be awarded for completing this level
function calculateStars( scoreCollected, healthLeft )
	if scoreCollected >= ( enemiesSpawned * maxPointsPerEnemy() * 0.65 ) and healthLeft > 3 then
		return 3
	elseif scoreCollected >= ( enemiesSpawned * maxPointsPerEnemy() * 0.35 ) and healthLeft > 1 then
		return 2
	else
		return 1
	end
end

-- for reporting main engine the amount of enemies destroyed during this level
function enemiesDestroyedInLevel()
	return enemiesDestroyed
end

-- for reporting main engine how many enemies there are to come during this level
function enemiesTotalInLevel()
	return 200
end
